// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ErrorBar.pas' rev: 3.00

#ifndef ErrorBarHPP
#define ErrorBarHPP
#include <TeCanvas.hpp>
#include <Series.hpp>
#include <TeEngine.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Errorbar
{
//-- type declarations -------------------------------------------------------
enum TErrorSeriesStyle { essLeft, essRight, essLeftRight, essTop, essBottom, essTopBottom };

enum TErrorWidthUnits { ewuPercent, ewuPixels };

class DELPHICLASS TCustomErrorSeries;
class PASCALIMPLEMENTATION TCustomErrorSeries : public Series::TBarSeries 
{
	typedef Series::TBarSeries inherited;
	
private:
	Tecanvas::TChartPen* FErrorPen;
	TErrorSeriesStyle FErrorStyle;
	Teengine::TChartValueList* FErrorValues;
	int FErrorWidth;
	TErrorWidthUnits FErrorWidthUnits;
	bool IDrawBar;
	double __fastcall GetErrorValue(int Index);
	void __fastcall PrepareErrorPen(int ValueIndex);
	void __fastcall SetErrorStyle(TErrorSeriesStyle Value);
	void __fastcall SetErrorValue(int Index, const double Value);
	void __fastcall SetErrorValues(Teengine::TChartValueList* Value);
	void __fastcall SetErrorWidthUnits(TErrorWidthUnits Value);
	void __fastcall SetErrorPen(Tecanvas::TChartPen* Value);
	void __fastcall SetErrorWidth(int Value);
	
protected:
	void __fastcall DrawError(int X, int Y, int AWidth, int AHeight, bool Draw3D);
	virtual void __fastcall SetSeriesColor(Graphics::TColor AColor);
	
public:
	__fastcall virtual TCustomErrorSeries(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomErrorSeries(void);
	int __fastcall AddErrorBar(const double AX, const double AY, const double AError, const System::AnsiString 
		AXLabel, Graphics::TColor AColor);
	virtual void __fastcall CalcHorizMargins(int &LeftMargin, int &RightMargin);
	virtual void __fastcall CalcVerticalMargins(int &TopMargin, int &BottomMargin);
	virtual void __fastcall DrawBar(int BarIndex, int StartPos, int EndPos);
	virtual void __fastcall DrawLegendShape(int ValueIndex, const Windows::TRect &Rect);
	virtual void __fastcall FillSampleValues(int NumValues);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual double __fastcall MinYValue(void);
	virtual double __fastcall MaxYValue(void);
	__property double ErrorValue[int Index] = {read=GetErrorValue, write=SetErrorValue};
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	__property Tecanvas::TChartPen* ErrorPen = {read=FErrorPen, write=SetErrorPen};
	__property TErrorSeriesStyle ErrorStyle = {read=FErrorStyle, write=SetErrorStyle, default=5};
	__property Teengine::TChartValueList* ErrorValues = {read=FErrorValues, write=SetErrorValues};
	__property int ErrorWidth = {read=FErrorWidth, write=SetErrorWidth, default=100};
	__property TErrorWidthUnits ErrorWidthUnits = {read=FErrorWidthUnits, write=SetErrorWidthUnits, default=0
		};
};

class DELPHICLASS TErrorSeries;
class PASCALIMPLEMENTATION TErrorSeries : public Errorbar::TCustomErrorSeries 
{
	typedef Errorbar::TCustomErrorSeries inherited;
	
__published:
	__property ErrorPen ;
	__property ErrorStyle ;
	__property ErrorValues ;
	__property ErrorWidth ;
	__property ErrorWidthUnits ;
public:
	/* TCustomErrorSeries.Create */ __fastcall virtual TErrorSeries(Classes::TComponent* AOwner) : Errorbar::
		TCustomErrorSeries(AOwner) { }
	/* TCustomErrorSeries.Destroy */ __fastcall virtual ~TErrorSeries(void) { }
	
};

class DELPHICLASS TErrorBarSeries;
class PASCALIMPLEMENTATION TErrorBarSeries : public Errorbar::TCustomErrorSeries 
{
	typedef Errorbar::TCustomErrorSeries inherited;
	
public:
	__fastcall virtual TErrorBarSeries(Classes::TComponent* AOwner);
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	
__published:
	__property ErrorPen ;
	__property ErrorValues ;
	__property ErrorWidth ;
	__property ErrorWidthUnits ;
public:
	/* TCustomErrorSeries.Destroy */ __fastcall virtual ~TErrorBarSeries(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Errorbar */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Errorbar;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// ErrorBar
