// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'GLCanvas.pas' rev: 3.00

#ifndef GLCanvasHPP
#define GLCanvasHPP
#include <TeCanvas.hpp>
#include <Controls.hpp>
#include <OpenGL2.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Glcanvas
{
//-- type declarations -------------------------------------------------------
typedef float GLMat[4];

class DELPHICLASS TGLCanvas;
class PASCALIMPLEMENTATION TGLCanvas : public Tecanvas::TCanvas3D 
{
	typedef Tecanvas::TCanvas3D inherited;
	
private:
	Graphics::TColor FBackColor;
	TCanvasBackMode FBackMode;
	int FDepth;
	int FTextAlign;
	bool FUseMaterial;
	int FWidth;
	int FHeight;
	int FXCenter;
	int FYCenter;
	Classes::TNotifyEvent FOnInit;
	int TheFontHandle;
	HDC FDC;
	HGLRC HRC;
	HPALETTE Palette;
	int FontOffset;
	int FX;
	int FY;
	int FZ;
	bool IFontCreated;
	void __fastcall TeeVertex2D(int x, int y);
	void __fastcall TeeVertex3D(int x, int y, int z);
	void __fastcall TeeNormal(int x, int y, int z);
	void __fastcall SetPenColor(void);
	void __fastcall InitMatrix(void);
	void __fastcall DoProjection(void);
	void __fastcall SetMaterial(Graphics::TColor AColor);
	
protected:
	void __fastcall InitFont(void);
	
public:
	__fastcall TGLCanvas(void);
	__fastcall virtual ~TGLCanvas(void);
	void __fastcall Repaint(void);
	virtual void __fastcall SetPixel(int X, int Y, Graphics::TColor Value);
	virtual bool __fastcall GetSupports3DText(void);
	virtual bool __fastcall GetSupportsFullRotation(void);
	virtual int __fastcall GetTextAlign(void);
	virtual bool __fastcall GetUseBuffer(void);
	virtual void __fastcall SetUseBuffer(bool Value);
	virtual HDC __fastcall GetHandle(void);
	virtual void __fastcall SetPixel3D(int X, int Y, int Z, Graphics::TColor Value);
	virtual void __fastcall SetBackMode(Tecanvas::TCanvasBackMode Mode);
	virtual bool __fastcall GetMonochrome(void);
	virtual void __fastcall SetMonochrome(bool Value);
	virtual void __fastcall SetBackColor(Graphics::TColor Color);
	virtual Tecanvas::TCanvasBackMode __fastcall GetBackMode(void);
	virtual Graphics::TColor __fastcall GetBackColor(void);
	virtual void __fastcall SetTextAlign(int Align);
	virtual void __fastcall Arc(int X1, int Y1, int X2, int Y2, int X3, int Y3, int X4, int Y4);
	virtual void __fastcall Draw(int X, int Y, Graphics::TGraphic* Graphic);
	virtual void __fastcall EraseBackground(const Windows::TRect &Rect);
	virtual void __fastcall FillRect(const Windows::TRect &Rect);
	virtual void __fastcall Frame3D(const Windows::TRect &Rect, Graphics::TColor TopColor, Graphics::TColor 
		BottomColor, int Width);
	virtual void __fastcall Ellipse(int X1, int Y1, int X2, int Y2);
	virtual void __fastcall LineTo(int X, int Y);
	virtual void __fastcall MoveTo(int X, int Y);
	virtual void __fastcall Pie(int X1, int Y1, int X2, int Y2, int X3, int Y3, int X4, int Y4);
	virtual void __fastcall Rectangle(int X0, int Y0, int X1, int Y1);
	virtual void __fastcall RoundRect(int X1, int Y1, int X2, int Y2, int X3, int Y3);
	virtual void __fastcall StretchDraw(const Windows::TRect &Rect, Graphics::TGraphic* Graphic);
	virtual void __fastcall TextOut(int X, int Y, const System::AnsiString Text);
	virtual void __fastcall DoRectangle(const Windows::TRect &Rect);
	virtual void __fastcall DoHorizLine(int X0, int X1, int Y);
	virtual void __fastcall DoVertLine(int X, int Y0, int Y1);
	virtual void __fastcall ClipRectangle(const Windows::TRect &Rect);
	virtual void __fastcall ClipCube(const Windows::TRect &Rect, int MinZ, int MaxZ);
	virtual void __fastcall UnClipRectangle(void);
	virtual void __fastcall GradientFill(const Windows::TRect &Rect, Graphics::TColor StartColor, Graphics::TColor 
		EndColor, Tecanvas::TGradientDirection Direction);
	virtual void __fastcall RotateLabel(int x, int y, const System::AnsiString St, int RotDegree);
	virtual void __fastcall RotateLabel3D(int x, int y, int z, const System::AnsiString St, int RotDegree
		);
	virtual void __fastcall Invalidate(void);
	virtual void __fastcall Line(int X0, int Y0, int X1, int Y1);
	virtual void __fastcall Polygon(const tagPOINT * Points, const int Points_Size);
	virtual void __fastcall Calculate2DPosition(int &x, int &y, int z);
	virtual tagPOINT __fastcall Calculate3DPosition(int x, int y, int z);
	virtual void __fastcall Projection(int MaxDepth, const Windows::TRect &Bounds, const Windows::TRect 
		&Rect);
	virtual Windows::TRect __fastcall InitWindow(Graphics::TCanvas* DestCanvas, Tecanvas::TView3DOptions* 
		A3DOptions, Graphics::TColor ABackColor, bool Is3D, const Windows::TRect &UserRect);
	virtual void __fastcall ShowImage(Graphics::TCanvas* DestCanvas, Graphics::TCanvas* DefaultCanvas, 
		const Windows::TRect &UserRect);
	virtual bool __fastcall ReDrawBitmap(void);
	virtual void __fastcall Arrow(bool Filled, const tagPOINT &FromPoint, const tagPOINT &ToPoint, int 
		ArrowWidth, int ArrowHeight, int Z);
	virtual void __fastcall Cube(int Left, int Right, int Top, int Bottom, int Z0, int Z1, bool DarkSides
		);
	virtual void __fastcall Cylinder(bool Vertical, int Left, int Top, int Right, int Bottom, int Z0, int 
		Z1, bool DarkCover);
	virtual void __fastcall EllipseWithZ(int X1, int Y1, int X2, int Y2, int Z);
	virtual void __fastcall RectangleZ(int Left, int Top, int Bottom, int Z0, int Z1);
	virtual void __fastcall RectangleY(int Left, int Top, int Right, int Z0, int Z1);
	virtual void __fastcall FrontPlaneBegin(void);
	virtual void __fastcall FrontPlaneEnd(void);
	virtual void __fastcall HorizLine3D(int Left, int Right, int Y, int Z);
	virtual void __fastcall LineTo3D(int X, int Y, int Z);
	virtual void __fastcall LineWithZ(int X0, int Y0, int X1, int Y1, int Z);
	virtual void __fastcall MoveTo3D(int X, int Y, int Z);
	virtual void __fastcall Pie3D(int XCenter, int YCenter, int XRadius, int YRadius, int Z0, int Z1, const 
		double StartAngle, const double EndAngle, bool DarkSides, bool DrawSides);
	virtual void __fastcall Plane3D(const tagPOINT &A, const tagPOINT &B, int Z0, int Z1);
	virtual void __fastcall PlaneWithZ(const tagPOINT &P1, const tagPOINT &P2, const tagPOINT &P3, const 
		tagPOINT &P4, int Z);
	virtual void __fastcall PlaneFour3D(const tagPOINT * Points, int Z0, int Z1);
	void __fastcall PolygonWithZ(const tagPOINT * Points, const int Points_Size, int Z);
	virtual void __fastcall Pyramid(bool Vertical, int Left, int Top, int Right, int Bottom, int z0, int 
		z1, bool DarkSides);
	virtual void __fastcall RectangleWithZ(const Windows::TRect &Rect, int Z);
	virtual void __fastcall TextOut3D(int X, int Y, int Z, const System::AnsiString Text);
	virtual void __fastcall TriangleWithZ(const tagPOINT &P1, const tagPOINT &P2, const tagPOINT &P3, int 
		Z);
	virtual void __fastcall VertLine3D(int X, int Top, int Bottom, int Z);
	virtual void __fastcall ZLine3D(int X, int Y, int Z0, int Z1);
	void __fastcall Sphere(int x, int y, int z, int Radius);
	__property Classes::TNotifyEvent OnInit = {read=FOnInit, write=FOnInit};
	__property bool UseMaterial = {read=FUseMaterial, write=FUseMaterial, nodefault};
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall ColorToGL(Graphics::TColor AColor, float * C);

}	/* namespace Glcanvas */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Glcanvas;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// GLCanvas
