// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'TeeSurfa.pas' rev: 3.00

#ifndef TeeSurfaHPP
#define TeeSurfaHPP
#include <Chart.hpp>
#include <TeCanvas.hpp>
#include <TeEngine.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Teesurfa
{
//-- type declarations -------------------------------------------------------
typedef double __fastcall (__closure *TChartSurfaceGetY)(Teengine::TChartSeries* Sender, int X, int 
	Z);

typedef void __fastcall (__closure *TChartSurfaceGetColor)(Teengine::TChartSeries* Sender, int ValueIndex
	, Graphics::TColor &Color);

class DELPHICLASS TCustom3DSeries;
class PASCALIMPLEMENTATION TCustom3DSeries : public Teengine::TChartSeries 
{
	typedef Teengine::TChartSeries inherited;
	
private:
	int FTimesZOrder;
	Teengine::TChartValueList* FZValues;
	void __fastcall SetTimesZOrder(int Value);
	void __fastcall SetZValues(Teengine::TChartValueList* Value);
	void __fastcall SetZValue(int Index, const double Value);
	double __fastcall GetZValue(int Index);
	bool __fastcall IsZValuesStored(void);
	
public:
	__fastcall virtual TCustom3DSeries(Classes::TComponent* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual int __fastcall AddXYZ(int AX, const double AY, int AZ, const System::AnsiString AXLabel, Graphics::TColor 
		AColor);
	virtual void __fastcall CalcZOrder(void);
	virtual bool __fastcall IsValidSourceOf(Teengine::TChartSeries* Value);
	virtual double __fastcall MaxZValue(void);
	virtual double __fastcall MinZValue(void);
	__property double ZValue[int Index] = {read=GetZValue, write=SetZValue};
	__property int TimesZOrder = {read=FTimesZOrder, write=SetTimesZOrder, default=3};
	__property Teengine::TChartValueList* ZValues = {read=FZValues, write=SetZValues, stored=IsZValuesStored
		};
public:
	/* TChartSeries.Destroy */ __fastcall virtual ~TCustom3DSeries(void) { }
	
};

typedef int TTeeCellsRow[500];

typedef TTeeCellsRow *PTeeCellsRow;

class DELPHICLASS TCustom3DGridSeries;
class PASCALIMPLEMENTATION TCustom3DGridSeries : public Teesurfa::TCustom3DSeries 
{
	typedef Teesurfa::TCustom3DSeries inherited;
	
private:
	Graphics::TColor FEndColor;
	TTeeCellsRow *FGridIndex[500];
	int FNumXValues;
	int FNumZValues;
	Classes::TList* FPalette;
	int FPaletteSteps;
	Graphics::TColor FStartColor;
	bool FUseColorRange;
	bool FUsePalette;
	TChartSurfaceGetY FOnGetYValue;
	TChartSurfaceGetColor FOnGetColor;
	bool IInGallery;
	int IRangeRed;
	int IEndRed;
	int IRangeGreen;
	int IEndGreen;
	int IRangeBlue;
	int IEndBlue;
	void __fastcall SetNumXValues(int Value);
	void __fastcall SetNumZValues(int Value);
	int __fastcall GetGridIndex(int X, int Z);
	void __fastcall InternalSetGridIndex(int X, int Z, int Value);
	void __fastcall SetGridIndex(int X, int Z, int Value);
	void __fastcall CalcColorRange(void);
	void __fastcall ClearGridIndex(void);
	
protected:
	void __fastcall SetPaletteSteps(int Value);
	void __fastcall SetStartColor(Graphics::TColor Value);
	void __fastcall SetEndColor(Graphics::TColor Value);
	void __fastcall SetUsePalette(bool Value);
	void __fastcall SetUseColorRange(bool Value);
	virtual void __fastcall AddValues(Teengine::TChartSeries* Source);
	virtual Graphics::TColor __fastcall GetValueColor(int ValueIndex);
	Graphics::TColor __fastcall GetValueColorValue(const double AValue);
	virtual void __fastcall DoBeforeDrawChart(void);
	
public:
	double RedFactor;
	double GreenFactor;
	double BlueFactor;
	__fastcall virtual TCustom3DGridSeries(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustom3DGridSeries(void);
	int __fastcall AddPalette(const double Value, Graphics::TColor Color);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	bool __fastcall CanCreateValues(void);
	virtual void __fastcall Clear(void);
	void __fastcall ClearPalette(void);
	void __fastcall CreateDefaultPalette(int NumSteps);
	virtual void __fastcall CreateValues(int NumX, int NumZ);
	virtual int __fastcall CountLegendItems(void);
	void __fastcall FillGridIndex(void);
	virtual void __fastcall FillSampleValues(int NumValues);
	virtual void __fastcall GalleryChanged3D(bool Is3D);
	Graphics::TColor __fastcall GetSurfacePaletteColor(const double Y);
	virtual double __fastcall GetXZValue(int X, int Z);
	virtual Graphics::TColor __fastcall LegendItemColor(int LegendIndex);
	virtual System::AnsiString __fastcall LegendString(int LegendIndex, Teengine::TLegendTextStyle LegendTextStyle
		);
	virtual int __fastcall NumSampleValues(void);
	void __fastcall ReCreateValues(void);
	__property Graphics::TColor EndColor = {read=FEndColor, write=SetEndColor, default=16777215};
	__property int GridIndex[int X][int Z] = {read=GetGridIndex, write=SetGridIndex};
	__property int NumXValues = {read=FNumXValues, write=SetNumXValues, default=10};
	__property int NumZValues = {read=FNumZValues, write=SetNumZValues, default=10};
	__property Classes::TList* Palette = {read=FPalette};
	__property int PaletteSteps = {read=FPaletteSteps, write=SetPaletteSteps, default=32};
	__property Graphics::TColor StartColor = {read=FStartColor, write=SetStartColor, default=8388608};
	__property bool UseColorRange = {read=FUseColorRange, write=SetUseColorRange, default=1};
	__property bool UsePalette = {read=FUsePalette, write=SetUsePalette, default=0};
	__property TChartSurfaceGetY OnGetYValue = {read=FOnGetYValue, write=FOnGetYValue};
	__property TChartSurfaceGetColor OnGetColor = {read=FOnGetColor, write=FOnGetColor};
};

class DELPHICLASS TSurfaceSeries;
class PASCALIMPLEMENTATION TSurfaceSeries : public Teesurfa::TCustom3DGridSeries 
{
	typedef Teesurfa::TCustom3DGridSeries inherited;
	
private:
	bool FWireFrame;
	bool FDotFrame;
	Tecanvas::TChartPen* FPen;
	Teengine::TChartBrush* FBrush;
	bool FSameBrush;
	tagPOINT Points[4];
	int ValueIndex0;
	int ValueIndex1;
	int ValueIndex2;
	int ValueIndex3;
	int INextXCell;
	int INextZCell;
	void __fastcall SetPen(Tecanvas::TChartPen* Value);
	void __fastcall SetBrush(Teengine::TChartBrush* Value);
	
protected:
	bool __fastcall ExistFourGridIndex(int X, int Z);
	void __fastcall SetDotFrame(bool Value);
	void __fastcall SetWireFrame(bool Value);
	virtual void __fastcall DrawAllValues(void);
	virtual void __fastcall DrawCell(int x, int z);
	tagPOINT __fastcall CalcPointPos(int Index);
	
public:
	__fastcall virtual TSurfaceSeries(Classes::TComponent* AOwner);
	__fastcall virtual ~TSurfaceSeries(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual int __fastcall Clicked(int x, int y);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	
__published:
	__property Teengine::TChartBrush* Brush = {read=FBrush, write=SetBrush};
	__property bool DotFrame = {read=FDotFrame, write=SetDotFrame, default=0};
	__property EndColor ;
	__property NumXValues ;
	__property NumZValues ;
	__property Tecanvas::TChartPen* Pen = {read=FPen, write=SetPen};
	__property PaletteSteps ;
	__property StartColor ;
	__property UseColorRange ;
	__property UsePalette ;
	__property bool WireFrame = {read=FWireFrame, write=SetWireFrame, default=0};
	__property TimesZOrder ;
	__property XValues ;
	__property YValues ;
	__property ZValues ;
	__property OnGetYValue ;
	__property OnGetColor ;
};

class DELPHICLASS TContourSeries;
typedef void __fastcall (__closure *TOnGetLevelEvent)(TContourSeries* Sender, int LevelIndex, double 
	&Value, Graphics::TColor &Color);

class PASCALIMPLEMENTATION TContourSeries : public Teesurfa::TCustom3DGridSeries 
{
	typedef Teesurfa::TCustom3DGridSeries inherited;
	
private:
	int FNumLevels;
	double FLevels[251];
	Graphics::TColor FLevelColors[251];
	Tecanvas::TChartPen* FPen;
	double FYPosition;
	bool FYPositionLevel;
	TOnGetLevelEvent FOnGetLevel;
	void __fastcall SetNumLevels(int Value);
	void __fastcall SetPen(Tecanvas::TChartPen* Value);
	void __fastcall SetYPosition(const double Value);
	void __fastcall SetYPositionLevel(bool Value);
	
protected:
	virtual void __fastcall DrawAllValues(void);
	virtual void __fastcall DoBeforeDrawChart(void);
	
public:
	__fastcall virtual TContourSeries(Classes::TComponent* AOwner);
	__fastcall virtual ~TContourSeries(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall FillSampleValues(int NumValues);
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual int __fastcall CountLegendItems(void);
	virtual Graphics::TColor __fastcall LegendItemColor(int LegendIndex);
	virtual System::AnsiString __fastcall LegendString(int LegendIndex, Teengine::TLegendTextStyle LegendTextStyle
		);
	
__published:
	__property ColorEachPoint ;
	__property EndColor ;
	__property int NumLevels = {read=FNumLevels, write=SetNumLevels, default=10};
	__property NumXValues ;
	__property NumZValues ;
	__property PaletteSteps ;
	__property Tecanvas::TChartPen* Pen = {read=FPen, write=SetPen};
	__property StartColor ;
	__property TimesZOrder ;
	__property UseColorRange ;
	__property UsePalette ;
	__property XValues ;
	__property double YPosition = {read=FYPosition, write=SetYPosition};
	__property bool YPositionLevel = {read=FYPositionLevel, write=SetYPositionLevel, default=0};
	__property YValues ;
	__property ZValues ;
	__property OnGetYValue ;
	__property TOnGetLevelEvent OnGetLevel = {read=FOnGetLevel, write=FOnGetLevel};
};

//-- var, const, procedure ---------------------------------------------------
#define MaxAllowedCells (Word)(500)
extern PACKAGE bool TeeSurfaceTriangles;
#define MaxLevels (Byte)(250)

}	/* namespace Teesurfa */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Teesurfa;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// TeeSurfa
